angular.module('ngApp').controller('PhotosCtrl', function ($scope, $rootScope, $ionicModal, $ionicScrollDelegate, $http, $sce) {

	$scope.content = '';

	$ionicModal.fromTemplateUrl('image-modal.html', {
		scope: $scope,
		animation: 'slide-in-up',
		hardwareBackButtonClose: true
	}).then(function($ionicModal) {
		$scope.modal = $ionicModal;
	});

	var updated = false;
	$scope.openModal = function(index) {
		$scope.modal.show();
		$rootScope.openModal = $scope.modal;
		if(!updated) {
			$scope.slider.update();
			updated = true;
		}
		$scope.slider.slideTo(index + $scope.fixLoop, 0, $scope.slideChanged(index));
	};

	$scope.closeModal = function() {
		$scope.modal.hide();
	};

	$scope.zoom = function(index){
		if($scope.inZoom){
			$ionicScrollDelegate.$getByHandle('zoom-pane-' + index).zoomTo(1, true);
			$scope.inZoom = false;
		}else{
			$ionicScrollDelegate.$getByHandle('zoom-pane-' + index).zoomTo(2, true);
			$scope.inZoom = true;
		}
	}
	// Called each time the slide changes
	$scope.slideChanged = function(index) {
		$ionicScrollDelegate.$getByHandle('zoom-pane-' + $scope.slider.previousIndex).zoomTo(1,true);
		$scope.slideIndex = index;
	};

	$scope.shareOnline = function(subject, imageID) {
		var image = document.getElementById(imageID);
		window.plugins.socialsharing.share(null, subject, image.src, null);
	}

	$scope.sharex = function(subject,imageID) {
		var image = document.getElementById(imageID);
		window.plugins.socialsharing.share(null, subject, getBase64Image(image), null);
	}

	function getBase64Image(img) {
		// Create an empty canvas element
		var canvas = document.createElement("canvas");
		canvas.width = img.width;
		canvas.height = img.height;
	
		// Copy the image contents to the canvas
		var ctx = canvas.getContext("2d");
		ctx.drawImage(img, 0, 0, img.width, img.height);

		// Get the data-URL formatted image
		var dataURL = canvas.toDataURL("image/png");
	
		return dataURL;
	}

	$scope.$watch('sl', function() {
		if(typeof($scope.sl) != 'undefined')
		{
			$scope.loading = true;

			$http({method: 'GET',cache: true, noLoading : true, url: url + '/api/v1/widget/route/photos/getImages/' + $scope.sl})
			.success(function(data) {
				if(typeof(data.images[0].image) != 'undefined'){
					$scope.images = data.images;
					$scope.colClass = data.class;
					$scope.share = data.share;
					$scope.content = $sce.trustAsHtml(data.content);
				}
				$scope.loading = false;
			})
			.error(function(){
				$scope.loading = false;
				$scope.content = $sce.trustAsHtml(lang('global.connection_error') + '<br>' + lang('global.check_your_internet_connection'));
				checkYourInternet();
			});
		}
	});

	$scope.$on("$ionicSlides.slideChangeStart", function(event, data){
		$scope.slideChanged($scope.slider.activeIndex)
	});

	$scope.$on("$ionicSlides.sliderInitialized", function(event, data){
	  // grab an instance of the slider
	  $scope.slider = data.slider;
	});

});
