(function (angular) {
    'use strict';
 
    function PZZCatSliderController ($scope, $element, $attrs) {
        var ctrl = this;

        this.$onInit = function () {
            ctrl.catBtnStyle = function (imgUrl) {
                if (imgUrl !== '' && imgUrl !== null) {
                    return {
                        'background-image': 'url('+imgUrl+')',
                        'background-position': 'center',
                        'background-repeat': 'no-repeat',
                        'background-size': 'cover'
                    }
                } else {
                    return {};
                }
            }
        }
    }

    angular.module('ngApp').component('pzzCatSlider', {
        bindings: {
            pageId: '@',
            categories: '<'
        },
        controller: PZZCatSliderController,
        template: 
        '   <div class="padding categories" ng-if="$ctrl.categories.length > 0">  '  + 
        '       <ion-scroll   '  + 
        '           direction="x"   '  + 
        '           zooming="false"   '  + 
        '           delegate-handle="categories"   '  + 
        '           horizontal-scroll-fix="mainScroll{{ $ctrl.pageId }}"  '  + 
        '       >  '  + 
        '           <div class="rtl" ng-style="$ctrl.categories.length <= 3 ? {\'width\': \'100%\'} : {}">  '  + 
        '               <a   '  + 
        '                   class="button button-assertive buttons-top"   '  + 
        '                   ng-repeat="category in $ctrl.categories"   '  + 
        '                   href="#{{ category.link }}"   '  + 
        '                   ng-bind="category.title"  '  + 
        '                   ng-style="$ctrl.catBtnStyle(category.image)"  '  + 
        '               ></a>  '  + 
        '           </div>  '  + 
        '       </ion-scroll>  '  + 
        '  </div>  '
    });
})(window.angular);