(function (angular) {
    'use strict';
 
    function PZZVideoListController ($scope, $element, $attrs) {
        var ctrl = this;

        this.$onInit = function () {
            ctrl.itemDisabled = ctrl.isClickable !== undefined && !ctrl.isClickable;

            if (ctrl.itemDisabled) {
                ctrl.customStyle = {
                    "background-color" : "#b2b2b2",
                }
            } else {
                ctrl.customStyle = {}
            }

            ctrl.onClick = function (item) {
                if (ctrl.itemDisabled) {
                    return;
                }
                ctrl.handleClick()(item);
            }
        }
    }

    angular.module('ngApp').component('pzzVideoList', {
        bindings: {
            videos: '<',
            layout: '@',
            handleClick: '&',
            isClickable: '<'
        },
        controller: PZZVideoListController,
        template: 
        '       <ion-item   '  + 
        '           ng-repeat="entry in $ctrl.videos track by $index"   '  + 
        '           class="item item{{ $index }} {{ $ctrl.layout }} item-contact"   '  + 
        '           ng-style="$ctrl.customStyle"  '  + 
        '           ng-click="$ctrl.onClick(entry)"  '  + 
        '       >  '  + 
        '           <img ng-if="$ctrl.layout != \'no-image\' && entry.thumb" ng-src="{{ entry.thumb || noImageUrl }}"/>  '  + 
        '           <h2 class="title">{{ entry.title }}</h2>  '  + 
        '           <div class="item-description">  '  + 
        '               <span ng-if="entry.duration">' +
        '                   <span style="position: relative; color: #A9A9A9;">' +
        '                       {{ entry.duration | secondsToHMS | persianNumber }} <i style="position: absolute; top: 3px; left: -12px;" class="icon ion-android-time"></i>' +
        '                   </span>' +
        '               </span>' +
        '               <span>' +
        '                   <span ng-if="entry.price && entry.pricable" class="price" style="position: relative"> ' +
        '                       {{ entry.price | toman }} ' +
        '                       <span style="position: absolute; top: -18px; right: 12px; font-size: 11px;" ng-if="entry.realprice" class="realprice">{{ entry.realprice | toman }}</span>  '  + 
        '                   </span>  '  + 
        '               </span>' +
        '           </div>  '  + 
        '      </ion-item>  '
    });
})(window.angular);