(function (angular) {
    'use strict';
 
    function PZZVideoSliderController ($scope, $element, $attrs) {
        var ctrl = this;

        this.$onInit = function () {

            if (ctrl.pageId === undefined) {
                ctrl.pageId = 0;
            }

            if (ctrl.horizontalScrollFixIndex === undefined) {
                ctrl.horizontalScrollFixIndex = 0;
            }

            ctrl.onClick = function (item) {
                ctrl.handleClick()(item);
            }
        }
    }

    angular.module('ngApp').component('pzzVideoSlider', {
        bindings: {
            title: '<',
            link: '<',
            videos: '<',
            pageId: '@',
            noImageLink: '@',
            handleClick: '&',
            horizontalScrollFixIndex: '@',
        },
        controller: PZZVideoSliderController,
        template:
        '       <div class="category-title title{{ $ctrl.index }}">  '  + 
        '           <a href="{{ $ctrl.link }}" ng-if="$ctrl.link != \'\'">  '  + 
        '               <h4 ng-bind-html="$ctrl.title"></h4>  '  + 
        '           </a>  '  + 
        '           <h4 ng-bind-html="$ctrl.title" ng-if="$ctrl.title == \'\'"></h4>  '  + 
        '       </div>  '  + 
        '       <div class="products-row">  '  + 
        '           <ion-scroll   '  + 
        '               direction="x"   '  + 
        '               zooming="false"   '  + 
        '               delegate-handle="horizontal{{ $ctrl.horizontalScrollFixIndex }}{{ $ctrl.pageId }}"   '  + 
        '               horizontal-scroll-fix="mainScroll{{ $ctrl.pageId }}"  '  + 
        '           >  '  + 
        '               <div class="rtl" ng-style="$ctrl.videos.length <= 2 ? {\'width\': \'100%\'} : {}">  '  + 
        '                   <ion-item   '  + 
        '                       ng-repeat="video in $ctrl.videos"   '  + 
        '                       ng-click="$ctrl.onClick(video)"  '  + 
        '                       class="item-complex"  '  + 
        '                   >  '  + 
        '                       <img ng-src="{{ video.thumb || noImageLink}}">  '  + 
        '                       <h4 class="title" ng-bind="video.title"></h4>  '  + 
        '                       <div class="item-description">  '  + 
        '                           <span ng-if="video.duration">' +
        '                               <span style="position: relative; color: #A9A9A9;">' +
        '                                   {{ video.duration | secondsToHMS | persianNumber }} <i style="position: absolute; top: 3px; left: -12px;" class="icon ion-android-time"></i>' +
        '                               </span>' +
        '                           </span>' +
        '                           <span>' +
        '                              <span ng-if="video.price && video.pricable" class="price" style="position: relative"> ' +
        '                                   {{ video.price | toman }} ' +
        '                                   <span style="position: absolute; top: -18px; right: 12px; font-size: 11px;" ng-if="video.realprice" class="realprice">{{ video.realprice | toman }}</span>  '  + 
        '                               </span>  '  + 
        '                           </span>' +
        '                       </div>  '  + 
        '                   </ion-item>  '  + 
        '               </div>  '  + 
        '           </ion-scroll>  '  + 
        '      </div>  '
    });
})(window.angular);